@file:OptIn(LowLevelApi::class)
@file:JvmName("_Row2VoidKt")
@file:Suppress("DuplicatedCode")

package ru.landgrafhomyak.db.serdha0.user_commons.executors

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.LowLevelApi
import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.runtime.Transaction

public suspend inline fun <qUE : Any> Transaction.executeWithParams(
	compiledQuery: _Query.Params2Void<qUE>,
	params: RowProducer0<qUE>
) {
	_safeAutoClose_I(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow
	)
}

public suspend inline fun <qUE : Any> Transaction.executeWithParams(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>
) {
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = {}
	)
}