@file:JvmName("_ReturnColumnKt")

package ru.landgrafhomyak.db.serdha0.user_commons.construction

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.queries.SelectQuery

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Simple.Constructor.Scope<qUE, ocUE>.returnColumnFromSubquery(
	name: String, column: Column<RT, DT, ocUE>
): Column<RT, DT, qUE> = this.returnColumn(name, this.selectColumnFromSubquery(column))

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, ocUE, *>.returnColumnFromLeft(
	name: String, column: Column<RT, DT, ocUE>
): Column<RT, DT, qUE> = this.returnColumn(name, this.selectColumnFromLeft(column))

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, *, ocUE>.returnColumnFromRight(
	name: String, column: Column<RT, DT, ocUE>
): Column<RT, DT, qUE> = this.returnColumn(name, this.selectColumnFromRight(column))

public fun <qUE : Any, ocUE : Any, RT : Any, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, *, ocUE>.returnColumnFromRightAsNullable(
	name: String, column: Column<RT, DT, ocUE>
): Column<RT?, DatabaseType.Nullable<RT, DT>, qUE> = this.returnColumn(name, this.selectColumnFromRightAsNullable(column))