@file:JvmName("_ProviderExtensionKt")

package ru.landgrafhomyak.db.serdha0.user_commons.types

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

@get:JvmName("U_INT_8")
public val DatabaseType.Provider.U_INT_8: U_INT_8 get() = U_INT_8(this)

@get:JvmName("U_INT_16")
public val DatabaseType.Provider.U_INT_16: U_INT_16 get() = U_INT_16(this)

@get:JvmName("U_INT_32")
public val DatabaseType.Provider.U_INT_32: U_INT_32 get() = U_INT_32(this)

@get:JvmName("U_INT_64")
public val DatabaseType.Provider.U_INT_64: U_INT_64 get() = U_INT_64(this)

@get:JvmName("S_INT_8")
public val DatabaseType.Provider.S_INT_8: S_INT_8 get() = S_INT_8(this)

@get:JvmName("S_INT_16")
public val DatabaseType.Provider.S_INT_16: S_INT_16 get() = S_INT_16(this)

@get:JvmName("S_INT_32")
public val DatabaseType.Provider.S_INT_32: S_INT_32 get() = S_INT_32(this)

@get:JvmName("S_INT_64")
public val DatabaseType.Provider.S_INT_64: S_INT_64 get() = S_INT_64(this)

@get:JvmName("FLOAT_32")
public val DatabaseType.Provider.FLOAT_32: FLOAT_32 get() = FLOAT_32(this)

@get:JvmName("FLOAT_64")
public val DatabaseType.Provider.FLOAT_64: FLOAT_64 get() = FLOAT_64(this)

@Suppress("ClassName", "PropertyName")
public class _StringTypesProvider internal constructor(private val _context: DatabaseType.Provider) {
	@get:JvmName("ASCII")
	public val ASCII: STRING.ASCII get() = STRING.ASCII(this._context)
	public fun ASCII(length: UInt, isFixedSize: Boolean): STRING.ASCII = STRING.ASCII(this._context, length, isFixedSize)

	@get:JvmName("UTF8")
	public val UTF8: STRING.UTF8 get() = STRING.UTF8(this._context)
	public fun UTF8(length: UInt, isFixedSize: Boolean): STRING.UTF8 = STRING.UTF8(this._context, length, isFixedSize)

	@get:JvmName("UTF16")
	public val UTF16: STRING.UTF16 get() = STRING.UTF16(this._context)
	public fun UTF16(length: UInt, isFixedSize: Boolean): STRING.UTF16 = STRING.UTF16(this._context, length, isFixedSize)

	public companion object {
		@Suppress("FunctionName")
		public fun _getContext(t: _StringTypesProvider): DatabaseType.Provider = t._context
	}
}

@get:JvmName("FLOAT_64")
public val DatabaseType.Provider.STRING: _StringTypesProvider get() = _StringTypesProvider(this)


